

using System;
using System.Runtime.Serialization;
using System.Xml;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationTFND2019
{
    /// <summary>
    /// TFND
    /// </summary>
    [DataContract(Name = "TFND", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class TFND
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public INT INT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public RP RP { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 3)]
        public Payee Payee { get; set; }
    }

    /// <summary>
    /// Supplier Business Address Details
    /// </summary>
    [DataContract(Name = "AddressDetailsBusiness", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class AddressDetailsBusiness
    {

        /// <summary>
        /// Supplier business address line 1
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string Line1T { get; set; }

        /// <summary>
        /// Supplier business address line 2
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string Line2T { get; set; }

        /// <summary>
        /// Supplier business address suburb, town or city
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string LocalityNameT { get; set; }

        /// <summary>
        /// Supplier business address postcode
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string PostcodeT { get; set; }

        /// <summary>
        /// Supplier business address state or territory
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string StateOrTerritoryC { get; set; }

        /// <summary>
        /// Supplier business address country code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string CountryC { get; set; }
    }

    /// <summary>
    /// Supplier Contact Details
    /// </summary>
    [DataContract(Name = "ElectronicContact", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class ElectronicContact
    {

        /// <summary>
        /// Supplier contact name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string PersonUnstructuredNameFullNameT { get; set; }

        /// <summary>
        /// Supplier contact telephone area code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TelephoneAreaC { get; set; }

        /// <summary>
        /// Supplier contact telephone number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TelephoneMinimalN { get; set; }

        /// <summary>
        /// Supplier contact e-mail address
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string ElectronicMailAddressT { get; set; }
    }

    /// <summary>
    /// Supplier Declaration
    /// </summary>
    [DataContract(Name = "Declaration", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class Declaration
    {

        /// <summary>
        /// Supplier declaration accepted indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool StatementAcceptedI { get; set; }

        /// <summary>
        /// Supplier date of declaration signed
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public DateTime SignatureD { get; set; }

        /// <summary>
        /// Supplier signatory identifier text
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string SignatoryIdentifierT { get; set; }
    }

    /// <summary>
    /// Supplier
    /// </summary>
    [DataContract(Name = "INT", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class INT
    {

        /// <summary>
        /// Supplier ABN
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Supplier Tax Agent Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentNumberId { get; set; }

        /// <summary>
        /// Supplier name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public AddressDetailsBusiness AddressDetailsBusiness { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 5)]
        public ElectronicContact ElectronicContact { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 6)]
        public Declaration Declaration { get; set; }
    }

    /// <summary>
    /// Payer
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class RP
    {

        /// <summary>
        /// Payer Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Payer Withholding Payer Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string WithholdingPayerNumberId { get; set; }

        /// <summary>
        /// Payer branch code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string OrganisationDetailsOrganisationBranchC { get; set; }

        /// <summary>
        /// Payer name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 5)]
        public AddressDetailsBusiness AddressDetailsBusiness { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 6)]
        public ElectronicContact ElectronicContact { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 7)]
        public Declaration Declaration { get; set; }
    }

    /// <summary>
    /// Payee Identifiers
    /// </summary>
    [DataContract(Name = "Identifiers", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class Identifiers
    {

        /// <summary>
        /// Payee Tax File Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// TFN exemption code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string IdentificationExemptionDetailsTFNExemptionTypeC { get; set; }

        /// <summary>
        /// Employment payroll identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string EmploymentPayrollNumberId { get; set; }
    }

    /// <summary>
    /// Payee Current Name
    /// </summary>
    [DataContract(Name = "PersonNameDetailsCurrent", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class PersonNameDetailsCurrent
    {

        /// <summary>
        /// Payee surname
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string FamilyNameT { get; set; }

        /// <summary>
        /// Payee first given name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string GivenNameT { get; set; }

        /// <summary>
        /// Payee second given name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string OtherGivenNameT { get; set; }
    }

    /// <summary>
    /// Payee Demographic Details
    /// </summary>
    [DataContract(Name = "PersonDemographicDetails", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class PersonDemographicDetails
    {

        /// <summary>
        /// Payee day of birth
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public int? BirthDm { get; set; }

        /// <summary>
        /// Payee month of birth
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public int? BirthM { get; set; }

        /// <summary>
        /// Payee year of birth
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public int? BirthY { get; set; }
    }

    /// <summary>
    /// Employment Details
    /// </summary>
    [DataContract(Name = "PaymentArrangement", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class PaymentArrangement
    {

        /// <summary>
        /// Payee terminated indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TerminationC { get; set; }

        /// <summary>
        /// Payee residency status
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string ResidencyTaxPurposesPersonStatusC { get; set; }

        /// <summary>
        /// Basis of payment code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string PaymentBasisC { get; set; }

        /// <summary>
        /// Tax free threshold claimed
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public bool TaxOffsetClaimTaxFreeThresholdI { get; set; }

        /// <summary>
        /// Study and training loan repayment indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public bool IncomeTaxPayAsYouGoWithholdingStudyAndTrainingLoanRepaymentI { get; set; }
    }

    /// <summary>
    /// Payee Declaration
    /// </summary>
    [DataContract(Name = "DeclarationHardCopy", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class DeclarationHardCopy
    {

        /// <summary>
        /// Payee declaration accepted indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool StatementAcceptedI { get; set; }

        /// <summary>
        /// Payee date declaration signed
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public DateTime? SignatureD { get; set; }
    }

    /// <summary>
    /// Payee
    /// </summary>
    [DataContract(Name = "Payee", Namespace = "http://www.sbr.gov.au/ato/tfnd")]
    public class Payee
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public Identifiers Identifiers { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public PersonNameDetailsCurrent PersonNameDetailsCurrent { get; set; }

        /// <summary>
        /// Payee previous surname
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string PreviousPersonNameDetailsFamilyNameT { get; set; }

        /// <summary>
        /// Payee Primary e-mail address
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string EmailAddressElectronicContactElectronicMailAddressT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 5)]
        public PersonDemographicDetails PersonDemographicDetails { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 6)]
        public AddressDetailsBusiness AddressDetailsResidential { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 7)]
        public PaymentArrangement PaymentArrangement { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 8)]
        public DeclarationHardCopy DeclarationHardCopy { get; set; }
    }
}
 
